unit ClockGUI;

interface

uses
  Winapi.Windows, Winapi.Messages,Winapi.ShlObj, System.SysUtils, DateUtils, MMsystem,
  System.Variants, System.Classes, Vcl.Graphics, Vcl.Controls, Vcl.Forms,
  Vcl.Dialogs, Vcl.PlatformDefaultStyleActnCtrls, Inifiles,
  Vcl.Menus, Vcl.ActnPopup, AdvTimePickerDropDown, Vcl.ExtCtrls, ColorButton,
  Vcl.StdCtrls, Vcl.Mask;

type
  TClockFrm = class(TForm)
    AdvWatch1: TAdvWatch;
    PopupActionBar1: TPopupActionBar;
    CloseDoubleclick1: TMenuItem;
    Move1: TMenuItem;
    transparentForm1: TMenuItem;
    N1: TMenuItem;
    MessageOneHour: TMenuItem;
    Message30Minutes: TMenuItem;
    Timer1: TTimer;
    MessageEveryMinute: TMenuItem;
    Stopmessaging1: TMenuItem;
    ClrBtnAppointment: TColorButton;
    Timer2: TTimer;
    Label1: TLabel;
    MaskEdit1: TMaskEdit;
    Timer3: TTimer;
    Edit1: TEdit;
    N2: TMenuItem;
    SetActionAppointment1: TMenuItem;
    ClrBtn_60_Interval: TColorButton;
    ClrBtn_30_Interval: TColorButton;
    ClrBtn_1_Interval: TColorButton;
    ClrBtn_StopInterval: TColorButton;
    ClrBtnSpeech: TColorButton;
    ClrBtn_15_Interval: TColorButton;
    Message15minutes1: TMenuItem;
    procedure AdvWatch1DblClick(Sender: TObject);
    procedure Move1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure transparentForm1Click(Sender: TObject);
    procedure MessageOneHourClick(Sender: TObject);
    procedure Message30MinutesClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure MessageEveryMinuteClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Stopmessaging1Click(Sender: TObject);
    procedure ClrBtnAppointmentClick(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure Timer3Timer(Sender: TObject);
  //  procedure StartAction1Click(Sender: TObject);
    procedure MaskEdit1Enter(Sender: TObject);
    procedure ClrBtn_1_IntervalClick(Sender: TObject);
    procedure ClrBtn_30_IntervalClick(Sender: TObject);
    procedure ClrBtn_60_IntervalClick(Sender: TObject);
    procedure ClrBtnSpeechClick(Sender: TObject);
    procedure ClrBtn_15_IntervalClick(Sender: TObject);
    procedure Message15minutes1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ClockFrm         : TClockFrm;
  C4D_D11_appINI   : TIniFile;
  CFrm, ClockDir, LabelStr : String;
  SoundStr : PWideChar;
  Cl_InterV : Integer;

implementation

{$R *.dfm}



Uses CalendarGUI, MessageGUI;

Var  Time1 : Ttime;

function GetFolderPath(Wnd: HWnd; CSIDLFolder: Integer): string;
begin
  SetLength(Result, MAX_PATH);
  SHGetFolderPath(Wnd, CSIDLFolder, 0, 0, PChar(Result));
  SetLength(Result, StrLen(PChar(Result)));
  //specific for windows
  if (Result <> '') then Result  := IncludeTrailingBackslash(Result);
end;

function GetShellFolder(CSIDLFolder : integer) : string;
begin
  SetLength(Result, MAX_PATH);
  SHGetSpecialFolderPath(0, PChar(Result), CSIDLFolder, false);
  SetLength(Result, StrLen(PChar(Result)));
  //specific for windows
  if (Result <> '') then Result  := IncludeTrailingBackslash(Result);
end;

////////////////////////////////////////////////////////////////////////////////

procedure TClockFrm.FormCreate(Sender: TObject);
begin
  Timer1.Enabled := False;
  Timer2.Enabled := False;
  Cl_InterV   := 0;
  LabelStr    := '';

  CalendarFrm.Visible := False;
end;

////////////////////////////////////////////////////////////////////////////////

procedure TClockFrm.AdvWatch1DblClick(Sender: TObject);
begin
  C4D_D11_appINI := TIniFile.Create(ChangeFileExt(CFrm,'.ini')) ;
  try
  with C4D_D11_appINI,  ClockFrm do
    begin
      WriteInteger('ClockPlacement','Top', Top) ;
      WriteInteger('ClockPlacement','Left', Left) ;
      WriteInteger('ClockPlacement','Width', Width) ;
      WriteInteger('ClockPlacement','Height', Height) ;
    end;
  finally
    C4D_D11_appINI.Free;
  end;

  Close;

  CalendarFrm.Visible := True;
end;

procedure TClockFrm.MaskEdit1Enter(Sender: TObject);
begin
  Edit1.Visible := True
end;

///////////////////////////// MESSAGES /////////////////////////////////////////

procedure TClockFrm.MessageOneHourClick(Sender: TObject); {1h}
var TriggerTime   : TTime;
begin

  Timer1.Enabled  := True;
  TriggerTime     :=  TTime(Frac(Now)); // when to trigger the timer
  Timer1.Interval :=  round((TriggerTime) + 3600000);

  SoundStr        := './wav/Nightingale_song.wav';
  MessageFrm.Edit1.Text := 'This is a one hour reminder!';

end;

procedure TClockFrm.Message30MinutesClick(Sender: TObject); {30M}
var TriggerTime   : TTime;
begin

  Timer1.Enabled  := True;
  TriggerTime     :=  TTime(Frac(Now)); // when to trigger the timer
  Timer1.Interval :=  round((TriggerTime) + 1800000);

  SoundStr        := './wav/Poppeye.wav';
  MessageFrm.Edit1.Text := 'This is a half hour reminder!';

end;

procedure TClockFrm.Message15minutes1Click(Sender: TObject); {15M}
var TriggerTime   : TTime;
begin

  Timer1.Enabled  := True;
  TriggerTime     :=  TTime(Frac(Now)); // when to trigger the timer
  Timer1.Interval :=  round((TriggerTime) + 90000);

  SoundStr        := './wav/Nightingale_song.wav';
  MessageFrm.Edit1.Text := 'This is a quarter hour reminder!';

end;

procedure TClockFrm.MessageEveryMinuteClick(Sender: TObject); {1M}
var TriggerTime   : TTime;
begin

  Timer1.Enabled  := True;
  TriggerTime     :=  TTime(Frac(Now)); // when to trigger the timer
  Timer1.Interval :=  round((TriggerTime) + 5000);  // kept short fore testing

 // SoundStr        := './wav/pacman_dies_y.wav';
 // SoundStr        := './wav/pacman_intro.wav';
  SoundStr        := './wav/boop-boop2.wav';
  MessageFrm.Edit1.Text := '';
 // MessageFrm.Edit1.Text := 'This is a one minute reminder!';

end;

procedure TClockFrm.Stopmessaging1Click(Sender: TObject);
begin

  Timer1.Enabled  := False;

end;

/////////////////////////   MOVE + TRANSPAR  ////////////////////////////////////

procedure TClockFrm.Move1Click(Sender: TObject);
begin

  BorderStyle := bsToolWindow;
  TransparentColor := False;
  color := clred;

  CalendarFrm.WindowState := TWindowState.wsMinimized;

end;

procedure TClockFrm.transparentForm1Click(Sender: TObject);
begin

  BorderStyle           := bsNone;
  TransparentColor      := True;
  TransparentColorValue := Clred;

end;

///////////////////////   TIMERS  //////////////////////////////////////////////

// Timer1
procedure TClockFrm.Timer1Timer(Sender: TObject);
begin

  sndPlaySound(SoundStr, SND_FILENAME or SND_ASYNC);

  If MessageFrm = Nil Then MessageFrm := TMessageFrm.Create(Self);
  MessageFrm.ClrBtnEditSpeakClick(Sender);

end;

// Timer2
procedure TClockFrm.Timer2Timer(Sender: TObject);
begin

  Timer2.Enabled := false;
  sndPlaySound(SoundStr, SND_FILENAME or SND_ASYNC);

  If MessageFrm = Nil Then MessageFrm := TMessageFrm.Create(Self);

end;

// Timer3
procedure TClockFrm.Timer3Timer(Sender: TObject);
begin

  Label1.Caption :=  TimeToStr(Now)

end;

////////////////////////////////////////////////////////////////////////////////

procedure TClockFrm.ClrBtnAppointmentClick(Sender: TObject);
var TriggerTime, NowTime: TTime;
begin

  if Maskedit1.Text = '  :  :  ' then ShowMessage('You must enter a time')
  else
  begin
    TriggerTime     :=StrToTime(Maskedit1.Text); // when to trigger the timer
    NowTime:=TTime(Frac(Now));
    Timer2.Interval := round((TriggerTime - NowTime) * 86400 * 1000);
    Timer2.Enabled  := true;
    SoundStr        := './wav/Nightingale_song.wav';
    Edit1.Visible   := False;
    Maskedit1.Text  := '  :  :  ';
  end;

end;

//////////////////////////  Interval Buttons  //////////////////////////////////

procedure TClockFrm.ClrBtn_1_IntervalClick(Sender: TObject);
var TriggerTime : TTime;
begin

  Timer1.Enabled  := True;
  TriggerTime     :=  TTime(Frac(Now)); // when to trigger the timer
  Timer1.Interval :=  round((TriggerTime) + 5000);  // kept short fore testing

  SoundStr        := '';
  MessageFrm.Edit1.Text := 'This is a quick reminder!';

end;

procedure TClockFrm.ClrBtn_15_IntervalClick(Sender: TObject);
var TriggerTime : TTime;
begin

  Timer1.Enabled  := True;
  TriggerTime     :=  TTime(Frac(Now)); // when to trigger the timer
  Timer1.Interval :=  round((TriggerTime) + 900000);

  SoundStr        := '';
  MessageFrm.Edit1.Text := 'This is a quarter hour reminder!';

end;

procedure TClockFrm.ClrBtn_30_IntervalClick(Sender: TObject);
var TriggerTime : TTime;
begin

  Timer1.Enabled  := True;
  TriggerTime     := TTime(Frac(Now)); // when to trigger the timer
  Timer1.Interval :=  round((TriggerTime) + 1800000);

  SoundStr        := '';
  MessageFrm.Edit1.Text := 'This is a half hour reminder!';

end;

procedure TClockFrm.ClrBtn_60_IntervalClick(Sender: TObject);
var TriggerTime : TTime;
begin

  Timer1.Enabled  := True;
  TriggerTime     := TTime(Frac(Now)); // when to trigger the timer
  Timer1.Interval:=  round((TriggerTime) + 3600000);

  SoundStr        := './wav/Nightingale_song.wav';
  MessageFrm.Edit1.Text := 'This is a one hour reminder!';
  //If you want a pre-heare:
  sndPlaySound(SoundStr, SND_FILENAME or SND_ASYNC); //  Otherwise disable it
  MessageFrm.ClrBtnEditSpeakClick(Sender);   //  Otherwise disable it

end;

procedure TClockFrm.ClrBtnSpeechClick(Sender: TObject);
begin

  If MessageFrm = Nil Then MessageFrm := TMessageFrm.Create(Self);
  MessageFrm.Show;
  MessageFrm.Visible := True;
  MessageFrm.left:= ClockFrm.Left;
  MessageFrm.Top := ClockFrm.Height + 30;
  MessageFrm.LabelMessage.Caption :='No Message yet';

end;

////////////////////////////////////////////////////////////////////////////////

procedure TClockFrm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
  IniFilename: string;
begin    //remember the settings:

  IniFilename:=ChangeFileExt(CFrm,'.ini');
  C4D_D11_appINI := TIniFile.Create(IniFilename) ;
  try
    try
      with C4D_D11_appINI do
        begin
          WriteInteger('ClockPlacement','Top', Top) ;
          WriteInteger('ClockPlacement','Left', Left) ;
          WriteInteger('ClockPlacement','Width', Width) ;
          WriteInteger('ClockPlacement','Height', Height) ;
        end;
    except
      on E: Exception do begin
        ShowMessage('TClockFrm.FormCloseQuery '+E.Message+' '+IniFilename+' '+BoolToStr(DirectoryExists((ExtractFilePath(IniFilename)))));
      end;
    end;
  finally
    C4D_D11_appINI.Free;
  end;

  CalendarFrm.Visible:= true;
  CalendarFrm.WindowState := TWindowState.wsNormal;

end;



end.
