unit MessageGUI;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, Vcl.Menus, Vcl.StdCtrls,
  ColorButton, WEBLib.WebCtrls, VCL.TMSFNCTypes, VCL.TMSFNCUtils,
  VCL.TMSFNCGraphics, VCL.TMSFNCGraphicsTypes, VCL.TMSFNCCustomControl,
  VCL.TMSFNCWebBrowser, VCL.TMSFNCCustomWEBControl,
  VCL.TMSFNCCustomWEBComponent, VCL.TMSFNCWXSpeechSynthesis;

type
  TMessageFrm = class(TForm)
    LabelMessage: TLabel;
    Edit1: TEdit;
    Timer1: TTimer;
    Timer2: TTimer;
    ColorButton1: TColorButton;
    TMSFNCWXSpeechSynthesis1: TTMSFNCWXSpeechSynthesis;
    Memo1: TMemo;
    ClrBtnSaveVoiceSlect: TColorButton;
    ComboBox1: TComboBox;
    ClrBtnPause: TColorButton;
    ClrBtnResume: TColorButton;
    ColorButton5: TColorButton;
    ClrBtnFormClose: TColorButton;
    ClrBtnEditSpeak: TColorButton;
    procedure Timer1Timer(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure LabelMessageClick(Sender: TObject);
    procedure ColorButton1Click(Sender: TObject);
    procedure ClrBtnSaveVoiceSlectClick(Sender: TObject);
    procedure ClrBtnPauseClick(Sender: TObject);
    procedure ClrBtnResumeClick(Sender: TObject);
    procedure ColorButton5Click(Sender: TObject);
    procedure TMSFNCWXSpeechSynthesis1VoiceReady(Sender: TObject);
    procedure ClrBtnFormCloseClick(Sender: TObject);
    procedure ClrBtnEditSpeakClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MessageFrm: TMessageFrm;




implementation


{$R *.dfm}


procedure TMessageFrm.LabelMessageClick(Sender: TObject);
begin
  Close;
end;

procedure TMessageFrm.Timer1Timer(Sender: TObject);
begin
  LabelMessage.Visible := True;

  Timer1.Enabled  := False;
  Timer2.Enabled  := True;
end;

procedure TMessageFrm.Timer2Timer(Sender: TObject);
begin

  LabelMessage.Visible := False;
  Timer1.Enabled  := True;
end;

procedure TMessageFrm.ColorButton1Click(Sender: TObject);
var i:integer;
begin
  for i := 0 to Memo1.Lines.Count -1 do
  begin
    TMSFNCWXSpeechSynthesis1.Speak(Memo1.Lines[i])
  end;
end;



procedure TMessageFrm.ClrBtnEditSpeakClick(Sender: TObject);
begin
  TMSFNCWXSpeechSynthesis1.Cancel;
  TMSFNCWXSpeechSynthesis1.Speak(Edit1.Text);
end;

procedure TMessageFrm.ClrBtnSaveVoiceSlectClick(Sender: TObject);
begin
  TMSFNCWXSpeechSynthesis1.Voice := ComboBox1.Items[ComboBox1.ItemIndex];
end;

procedure TMessageFrm.ClrBtnPauseClick(Sender: TObject);
begin
  TMSFNCWXSpeechSynthesis1.Pause;
end;

procedure TMessageFrm.ClrBtnResumeClick(Sender: TObject);
begin
  TMSFNCWXSpeechSynthesis1.Resume;
end;

procedure TMessageFrm.ColorButton5Click(Sender: TObject);
begin
   TMSFNCWXSpeechSynthesis1.Cancel;
end;

procedure TMessageFrm.ClrBtnFormCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TMessageFrm.TMSFNCWXSpeechSynthesis1VoiceReady(Sender: TObject);
var  i : integer;
begin
  ComboBox1.Items := TMSFNCWXSpeechSynthesis1.Voices;

end;

end.
